$(function() {
    var debug = false;
    var targetClick = false,
        targetScroll = false,
        targetMouseMove = false;
    var metricObj = null;
    var curX = 0, curY = 0;
    var lastX = 0, lastY = 0;
    var path = 0;
    var pathBarier = 500;
    var timer = 100;
    var counter = 0;
    
    var minPath = function(lastX, lastY, curX, curY) {
        if (curX == lastX) return Math.abs(curY - lastY);
        if (curY == lastY) return Math.abs(curX - lastX);

        return Math.round(Math.sqrt(Math.abs(curX - lastX)*Math.abs(curX - lastX) + Math.abs(curY - lastY)*Math.abs(curY - lastY)), 0);
    };
    var pathCalculator = function() {
        lastX = lastX == 0 ? curX : lastX;
        lastY = lastY == 0 ? curY : lastY;

        var pp = path += minPath(lastX, lastY, curX, curY);
        lastX = curX, lastY = curY;
        counter += 1;

        if (counter > timer) {
            clearInterval(calcPath);
            if (path >= pathBarier) {
                if (!targetMouseMove) {                        
                    if (initMetricObj()) metricObj.reachGoal('pageMousemove');
                    if (debug) console.log('TARGET GOAL `pagePath`: ' + path);
                }
                targetMouseMove = true;
            } else {
                if (debug) console.log('NO GOAL `pagePath`: ' + path );
            }
        }
    };
    
    // Target targetLink
    $('a').click(function() {
        if (initMetricObj()) metricObj.reachGoal('targetLink');
        if (debug) console.log('TARGET GOAL `targetLink`');
    });
    
    // Target mouseMove
    $('body').on('mousemove', function(e) {
        curX = e.offsetX == undefined ? e.layerX : e.offsetX;
        curY = e.offsetY == undefined ? e.layerY : e.offsetY;
    });

    pathCalculator();
    var calcPath = setInterval(pathCalculator, 50);

    // Target clickOnPage
    $('html').on('click', '*', function() {
        if (!targetClick) {
            if (initMetricObj()) metricObj.reachGoal('pageClick');
            if (debug) console.log('TARGET GOAL `pageClick`');
        }
        targetClick = true;
    });

    // Target scrollPage
    $(window).scroll(function() {
        if (!targetScroll) {
            if (initMetricObj()) metricObj.reachGoal('pageScroll');
            if (debug) console.log('TARGET GOAL `pageScroll`');
        }
        targetScroll = true;
    });
    
    function initMetricObj() {
        if (metricObj == null) {
            metricObj = eval('yaCounter' + yaMetricId);
        }
        return metricObj == null ? false : true;
    }
});